let observerCallbacks = null;
let intersectionObserver = null;

function handleObserverCallbacks(entries) {
  entries.map((entry, i) => {
    let oldCallbacks = observerCallbacks.get(entry.target);
    oldCallbacks.length && oldCallbacks.forEach(callback => {
      callback && callback(entry);
    });
  });
}

export function addIntersectionObserver(element, callback, options) {
  if (intersectionObserver === null && observerCallbacks === null) {
    intersectionObserver = new IntersectionObserver(entries => {
      handleObserverCallbacks(entries);
    }, options);
    observerCallbacks = new Map();
  }

  intersectionObserver.observe(element);
  let oldCallbacks = observerCallbacks.get(element) || [];
  observerCallbacks.set(element, [...oldCallbacks, callback]);
}
export function removeIntersectionObserver(element, callback) {
  let oldCallbacks = observerCallbacks ? observerCallbacks.get(element) : [];
  oldCallbacks = oldCallbacks.filter(handler => handler !== callback);

  if (intersectionObserver && oldCallbacks.length === 0) {
    observerCallbacks.delete(element);
    intersectionObserver.unobserve(element);
  }

  if (intersectionObserver && observerCallbacks && observerCallbacks.size === 0) {
    intersectionObserver.disconnect();
    intersectionObserver = null;
    observerCallbacks = null;
  }
}