"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addIntersectionObserver = addIntersectionObserver;
exports.removeIntersectionObserver = removeIntersectionObserver;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var observerCallbacks = null;
var intersectionObserver = null;

function handleObserverCallbacks(entries) {
  entries.map(function (entry, i) {
    var oldCallbacks = observerCallbacks.get(entry.target);
    oldCallbacks.length && oldCallbacks.forEach(function (callback) {
      callback && callback(entry);
    });
  });
}

function addIntersectionObserver(element, callback, options) {
  if (intersectionObserver === null && observerCallbacks === null) {
    intersectionObserver = new IntersectionObserver(function (entries) {
      handleObserverCallbacks(entries);
    }, options);
    observerCallbacks = new Map();
  }

  intersectionObserver.observe(element);
  var oldCallbacks = observerCallbacks.get(element) || [];
  observerCallbacks.set(element, [].concat(_toConsumableArray(oldCallbacks), [callback]));
}

function removeIntersectionObserver(element, callback) {
  var oldCallbacks = observerCallbacks ? observerCallbacks.get(element) : [];
  oldCallbacks = oldCallbacks.filter(function (handler) {
    return handler !== callback;
  });

  if (intersectionObserver && oldCallbacks.length === 0) {
    observerCallbacks["delete"](element);
    intersectionObserver.unobserve(element);
  }

  if (intersectionObserver && observerCallbacks && observerCallbacks.size === 0) {
    intersectionObserver.disconnect();
    intersectionObserver = null;
    observerCallbacks = null;
  }
}